#ifndef __GAME_HPP__
#define __GAME_HPP__

struct killdata {
    s8 idx;
    u8 type;
    s8 beat;
};

struct EnemyData {
    s16 x;
    s16 y;
    u8 z;
    u16 cx;
    u8 cy;
    s8 next;
    s8 prev;
    u8 state;
};
struct MissileData {
    s16 x;
    s16 y;
    u8 z;
    u16 cx;
    u8 cy;
    u8 cz;
    s16 dx;
    s16 dy;
    u8 dz;
    s8 next;
    s8 prev;
    u8 state;
};
struct SampleData {
    s8 * d;
    s8 * p;
    u32 c;
    u32 l;
    u8 v;
    u8 pval[64];
};

struct SfxData {
    s8 * d;
    s8 * p;
};

struct MixData {
    u8 num;
    s8 smp1;
    s8 smp2;
    s8 smp3;
};

struct MixerData {
    s8 beat;
    u8 bar;
    u32 c;
    u32 sfxc;
    u8 numSfx;
    u8 numHit;
    u8 cSfx;
    u8 cHit;
    SfxData *sfx;
    u8 sfxidx;
    u32 sampleSize;
    u16 sampleBeat;
    u16 sampleBeat16;
    u8 numSamps;
    SampleData *smps;
    u16 loopsize;
    u16 count;
    MixData *mix;
};

#endif //__GAME_HPP__

