extern s8 sample1[];
extern s8 sample2[];
extern s8 sample3[];
extern s8 sample4[];
extern s8 sample5[];
extern s8 sample6[];
extern s8 sample7[];
extern s8 sample8[];
extern s8 sample9[];
extern s8 sfx1[];
extern s8 sfx2[];
extern s8 sfx3[];
extern s8 sfx4[];
extern s8 sfx5[];
extern s8 sfx6[];
extern s8 hit1[];
extern s8 hit2[];
extern u8 whirl1[];
extern u8 whirl2[];
extern u8 whirl3[];
extern u8 whirl4[];
extern u8 whirl5[];
extern u8 whirl6[];
extern u8 whirl7[];
extern u8 whirl8[];
extern u8 whirl1a[];
extern u8 whirl2a[];
extern u8 whirl3a[];
extern u8 whirl4a[];
extern u8 whirl5a[];
extern u8 whirl6a[];
extern u8 whirl7a[];
extern u8 whirl8a[];
extern u8 objtiles[];
extern u16 objpal[];

// Background animation
u8 *whirl[] = {whirl1, whirl1a, whirl2, whirl2a, whirl3, whirl3a, whirl4, whirl4a,
                whirl5, whirl5a, whirl6, whirl6a, whirl7, whirl7a, whirl8, whirl8a};

#define MIX_NORMAL  0x00
#define MIX_END     0x01
#define MIX_SFX     0x02

#define SAMPLELEN   127984
#define SAMPLEBAR   31996
#define SAMPLE16    1999
#define MIX_LENGTH  32

#define MIX_SFX_KILL_NUM 6
#define MIX_SFX_KILL(x) x
#define MIX_SFX_HIT(x) (MIX_SFX_KILL_NUM + x)

// Sound Effects
#define SFX1 {sfx1, sfx1}
#define SFX2 {sfx2, sfx2}
#define SFX3 {sfx3, sfx3}
#define SFX4 {sfx4, sfx4}
#define SFX5 {sfx5, sfx5}
#define SFX6 {sfx6, sfx6}
#define HIT1 {hit1, hit1}
#define HIT2 {(s8*)((u32)hit1 + SAMPLE16), (s8*)((u32)hit1 + SAMPLE16)}
#define HIT3 {hit2, hit2}
#define HIT4 {(s8*)((u32)hit2 + SAMPLE16), (s8*)((u32)hit2 + SAMPLE16)}

// Palette shifts for each sample
#define SMP1 {sample1, sample1, 0, SAMPLELEN, 0, \
    { 20, 15,  0, 20, 15,  0, 20, 15,  0,  0,  0,  0,  0,  0, 15, 15, \
      20, 15,  0,  0,  0,  0,  0, 15, 10,  0,  0,  0,  0,  0, 15, 15, \
      20, 15,  0, 20, 15,  0, 20, 15,  0,  0,  0,  0,  0,  0, 15, 15, \
      20, 15,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 15, 15 } \
}
#define SMP2 {sample2, sample2, 0, SAMPLELEN, 0, \
    {  6,  0,  3,  0,  6,  0,  3,  0,  6,  0,  3,  0,  6,  0,  3,  0, \
       6,  0,  3,  0,  6,  0,  3,  0,  6,  0,  3,  0,  6,  0,  3,  0, \
       6,  0,  3,  0,  6,  0,  3,  0,  6,  0,  3,  0,  6,  0,  3,  0, \
       6,  0,  3,  0,  6,  0,  3,  0,  6,  0,  3,  0,  6,  0,  3,  0 }\
}
#define SMP3 {sample3, sample3, 0, SAMPLELEN, 0, \
    {  5,  0,  0,  0,  8,  0,  0,  0,  5,  0,  0,  0,  5,  7,  5,  3, \
       5,  0,  0,  0,  8,  0,  0,  0,  5,  0,  0,  0,  5,  7,  5,  3, \
       5,  0,  0,  0,  8,  0,  0,  0,  5,  0,  0,  0,  5,  7,  5,  3, \
       5,  0,  0,  0,  8,  0,  0,  0,  5,  0,  0,  0, 10,  0,  0,  0, } \
}
#define SMP4 {sample4, sample4, 0, SAMPLELEN, 0, \
    { 23, 15,  0, 23, 15,  0, 23, 15,  0,  0,  0,  0,  0,  0, 15, 15, \
      23, 15,  0, 23, 15,  0, 23, 15,  0,  0,  0,  0,  0,  0, 15, 15, \
      23, 15,  0, 23, 15,  0, 23, 15,  0,  0,  0,  0,  0,  0, 15, 15, \
      23, 15,  0, 23, 15,  0, 23, 15,  0,  0,  0,  0,  0,  0, 15, 15 } \
}
#define SMP5 {sample5, sample5, 0, SAMPLELEN, 0, \
    {  6,  0,  3,  0,  6,  0,  3,  0,  6,  0,  3,  0,  6,  0,  3,  0, \
       6,  0,  3,  0,  6,  0,  3,  0,  6,  0,  3,  0,  6,  0,  3,  0, \
       6,  0,  3,  0,  6,  0,  3,  0,  6,  0,  3,  0,  6,  0,  3,  0, \
       6,  0,  3,  0,  6,  0,  3,  0,  6,  0,  3,  0,  6,  0,  3,  0 }\
}
#define SMP6 {sample6, sample6, 0, SAMPLELEN, 0, \
    {  6,  0,  3,  0,  6,  0,  3,  0,  6,  0,  3,  0,  6,  0,  3,  0, \
       6,  0,  3,  0,  6,  0,  3,  0,  6,  0,  3,  0,  6,  0,  3,  0, \
       6,  0,  3,  0,  6,  0,  3,  0,  6,  0,  3,  0,  6,  0,  3,  0, \
       6,  0,  3,  0,  6,  0,  3,  0,  6,  0,  3,  0,  6,  0,  3,  0 }\
}
#define SMP7 {sample7, sample7, 0, SAMPLELEN, 0, \
    {  6,  0,  3,  0,  6,  0,  3,  0,  6,  0,  3,  0,  6,  0,  3,  0, \
       6,  0,  3,  0,  6,  0,  3,  0,  6,  0,  3,  0,  6,  0,  3,  0, \
       6,  0,  3,  0,  6,  0,  3,  0,  6,  0,  3,  0,  6,  0,  3,  0, \
       6,  0,  3,  0,  6,  0,  3,  0,  6,  0,  3,  0,  6,  0,  3,  0 }\
}
#define SMP8 {sample8, sample8, 0, SAMPLELEN, 0, \
    { 15, 10,  0,  0,  5,  0, 15, 15, 10,  0,  0,  0,  5,  0,  0,  0, \
      15, 10,  0,  0,  5,  0, 15, 15, 10,  0,  0,  0,  5,  0,  0,  0, \
      15, 10,  0,  0,  5,  0, 15, 15, 10,  0,  0,  0,  5,  0,  0,  0, \
      15, 10,  0,  0,  5,  0, 15, 15, 10,  0,  0,  0,  5,  0,  0,  0 }\
}
#define SMP9 {sample9, sample9, 0, SAMPLELEN, 0, \
    { 10,  8, 10,  8,  6,  8,  6,  4,  6,  4,  2,  4,  2,  0,  2,  0, \
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, \
      10,  8, 10,  8,  6,  8,  6,  4,  6,  4,  2,  4,  2,  0,  2,  0, \
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 }\
}

SampleData smps[9] = {SMP1, SMP2, SMP3, SMP4, SMP5, SMP6, SMP7, SMP8, SMP9};
SfxData sfxs[10] = {SFX1,SFX2,SFX3,SFX4,SFX5,SFX6,HIT1,HIT2,HIT3,HIT4};

// The mix loop
MixData mix[MIX_LENGTH] = {{1, 8, 0, 0},{1, 8, 0, 0},
                    {1, 0, 0, 0},{1, 0, 0, 0},
                    {1, 3, 0, 0},{1, 3, 0, 0},{1, 3, 0, 0},{1, 3, 0, 0},
                    {1, 1, 0, 0},{1, 4, 0, 0},{1, 5, 0, 0},{1, 6, 0, 0},
                    {2, 0, 1, 0},{2, 0, 4, 0},
                    {2, 3, 1, 0},{2, 3, 4, 0},{2, 3, 5, 0},{2, 3, 6, 0},
                    {3, 3, 1, 8},{3, 3, 4, 8},
                    {1, 2, 0, 0},{1, 2, 0, 0},
                    {1, 7, 0, 0},{1, 7, 0, 0},
                    {2, 7, 1, 0},{2, 7, 4, 0},{2, 7, 5, 0},{2, 7, 6, 0},
                    {3, 7, 1, 3},{2, 7, 4, 3},{2, 7, 5, 3},{2, 7, 6, 3} };
volatile MixerData Mixer = {
    0,          // beat
    0,          // bar
    0,          // c
    0,          //sfxc
    6,          //numSfx
    4,          //numHit
    0,          //cSfx
    0,          //cHit
    sfxs,       //sfx
    0,          //sfxidx
    SAMPLELEN,  //sampleSize
    SAMPLEBAR,  //sampleBeat
    SAMPLE16,   //sampleBeat16
    9,          //numSamps
    smps,       //smps
    MIX_LENGTH, //loopsize
    0,          //count
    mix         //mix
};

// Number of enemies and missiles during the level
const u8 maxE[MIX_LENGTH] = {12,12,14,14,16,16,16,16,
                             20,20,20,20,24,24,26,26,
                             26,26,32,32,16,16,18,18,
                             24,24,24,24,32,32,32,32};
const u8 maxM[MIX_LENGTH] = { 6, 6, 7, 7, 8, 8, 8, 8,
                             10,10,10,10,14,14,16,16,
                             16,16,20,20,16,16,18,18,
                             20,20,20,20,24,24,24,24};

